package imt.concours;

import static imt.concours.ConcoursTest.chef1;
import static imt.concours.ConcoursTest.jury1;
import static imt.concours.ConcoursTest.jury2;
import static imt.concours.ConcoursTest.jury3;
import static imt.concours.ConcoursTest.proposition1;
import static imt.concours.ConcoursTest.propositions;
import static org.assertj.core.api.Assertions.assertThat;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.jupiter.api.Test;

import imt.ingredients.Ingredient;
import imt.ingredients.Plat;
import imt.personnes.Chef;
import imt.personnes.Genre;
import imt.personnes.Specialite;

public class FileConcoursTest {
	@Test
	void fileDeConcours_tout_les_concours_du_chef() {
		Set<Proposition> propositionsSansTelChef = new HashSet<>(propositions);
		propositionsSansTelChef.remove(proposition1);
		propositionsSansTelChef.add(
				new Proposition(new Plat(99, "plat99", new Ingredient[] {}), new Chef(99, "nom99", "prenom99", "QSD",
						Genre.HOMME, 4, Specialite.CUISINIER, Set.of(new Plat(99, "plat99", new Ingredient[] {})))));

		Concours concours1 = new Concours(jury1, jury2, jury3, propositions);
		Concours concours2 = new Concours(jury1, jury2, jury3, propositionsSansTelChef);
		Concours concours3 = new Concours(jury1, jury2, jury3, new HashSet<>(propositions));

		FileConcours fileConcours = new FileConcours(concours1, concours2, concours3);

		assertThat(fileConcours.concoursAuquelParticipe(chef1)).isEqualTo(List.of(concours1, concours3));
	}
}
